commit 7b58a7e27afac52ca630d5db523503b75c732305
Author: Juergen Christ <jchrist@linux.ibm.com>
Date:   Mon Dec 9 15:26:54 2024 +0100

    s390: Fix UNSPEC_CC_TO_INT canonicalization
    
    Canonicalization of comparisons for UNSPEC_CC_TO_INT missed one case
    causing unnecessarily complex code.  This especially seems to hit the
    Linux kernel.
    
    gcc/ChangeLog:
    
            * config/s390/s390.cc (s390_canonicalize_comparison): Add
            missing UNSPEC_CC_TO_INT case.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/s390/ccusage.c: New test.
    
    Signed-off-by: Juergen Christ <jchrist@linux.ibm.com>
    (cherry picked from commit bdc572f9a42b6a68dec1a5593d5311f45bd29cc9)

diff --git a/gcc/config/s390/s390.cc b/gcc/config/s390/s390.cc
index a1c0a57a795..f2e4f5e101c 100644
--- a/gcc/config/s390/s390.cc
+++ b/gcc/config/s390/s390.cc
@@ -1859,7 +1859,7 @@ s390_canonicalize_comparison (int *code, rtx *op0, rtx *op1,
       && CONST_INT_P (XEXP (*op0, 1))
       && CONST_INT_P (*op1)
       && INTVAL (XEXP (*op0, 1)) == -3
-      && *code == EQ)
+      && (*code == EQ || *code == NE))
     {
       if (INTVAL (*op1) == 0)
 	{
diff --git a/gcc/testsuite/gcc.target/s390/ccusage.c b/gcc/testsuite/gcc.target/s390/ccusage.c
new file mode 100644
index 00000000000..e25f712e25c
--- /dev/null
+++ b/gcc/testsuite/gcc.target/s390/ccusage.c
@@ -0,0 +1,37 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -march=zEC12 -mzarch" } */
+
+static __attribute__((always_inline)) inline
+int __atomic_dec_and_test(int *ptr)
+{
+        int cc;
+        asm volatile(
+                "       alsi    %[ptr],-1\n"
+                : "=@cc" (cc), [ptr] "+QS" (*ptr) : : "memory");
+        return (cc == 0) || (cc == 2);
+}
+ 
+int a;
+void dummy(void);
+long fu(void)
+{
+        if (__atomic_dec_and_test(&a))
+                return 5;
+        return 8;
+}
+ 
+void bar(void)
+{
+        if (__atomic_dec_and_test(&a))
+                dummy();
+}
+
+int foo(int x)
+{
+        int cc;
+        asm volatile ("ahi %[x],42\n"
+                        : [x] "+d" (x), "=@cc" (cc));
+        return !(cc == 0 || cc == 2) ? 42 : 13;
+}
+
+/* { dg-final { scan-assembler-not {ipm} } } */

